/** 
 * fiwalk.h
 */

#include <algorithm>
#include <cstdlib>
#include <vector>
#include <string>

#include "bloom.h"
#include "bloomset.h"

using namespace std;

typedef vector<string> namelist_t;
extern namelist_t namelist;

extern bool opt_save;			// should we save content?
extern bool opt_magic;			// should we run libmagic?
extern bool opt_md5;			// do we need md5s?
extern bool opt_sha1;			// do we need sha1s?
extern bool opt_multithreaded;		// use multiple threading
extern string save_outdir;
extern bool opt_get_fragments;
extern bool opt_compute_sector_hashes;

void comment(const char *format,...);
void file_info(const string &name,const string &value);
void file_info(class threaded_hash &t);
void file_info_xml(const string &name,const string &value);
void file_info(const string name, int64_t value);
void file_infot(const string name,time_t t0);
extern u_int sector_size;			// of the current disk image
extern u_int sectorhash_size;		// for the computation of sector hashes
extern bloomset mybloomset;


extern class arff *a;
extern class xml *x;
